%% Compressed sensing with squared measurements
clc;clear;close all
n=32; % dim 
k=2; % nonzero elements
N=20; % # of measurements
figure

%% Generate data
x_true=randn(n,1)+i*randn(n,1);x_true=x_true./abs(x_true);
ind=randperm(n);
x_true(ind(1:n-k))=0;
A=randn(N,n)+i*randn(N,n);A=A./(norms(A,2,2)*ones(1,n))*dftmtx(n); 
y=A*x_true;
b=y.*conj(y);

%% PhaseLift using CVX
epsilon = 1e-3;
lambda = 0;
x_PR = CPRL_CVX(b,A,epsilon,lambda);

%% CPRL using CVX
epsilon = 1e-3;
lambda = 50;
x_CPRL = CPRL_CVX(b,A,epsilon,lambda);

%% CPRL using ADMM
filename_int = strcat('CPR_ADMM_int_results_lambda_',num2str(lambda));
[x_ADMM X_ADMM time_ADMM nIters X1 X2 Y1 Y2 filename] = CPRL_ADMM(A,b,lambda,[],filename_int,0,10000);
time_ADMM

%% Display the result
stem(abs(x_PR),'ko','filled')
hold on
stem(abs(x_CPRL),'kx')
stem(abs(x_ADMM),'rs')
axis([0 n 0 1])
legend('PL','CPRL (CVX)','CPRL (ADMM)')
disp('True nonzero elements: ')
ind(n-k+1:end)
